#=========================================================#
# onis 0.3.3                             2002-03-29 18:40 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# Config.pm                                               #
#=========================================================#

package Config;

use strict;

use vars qw(
		$config
	);

# loading defaults
$::user = (defined $ENV{'USER'} ? $ENV{'USER'} : 'onis');
$::channel = '';
$config->{'color'}{'background'}{'normal'} = '#000000';
$config->{'color'}{'text'}{'normal'} = '#bbbbbb';
$config->{'color'}{'text'}{'link'} = '#dddddd';
$config->{'color'}{'text'}{'vlink'} = '#cccccc';
$config->{'color'}{'text'}{'alink'} = '#ff0000';
$config->{'color'}{'background'}{'table'}{'header'} = '#aaaaaa';
$config->{'color'}{'text'}{'table'}{'header'} = '#333333';
$config->{'color'}{'background'}{'table'}{'side'} = '#888888';
$config->{'color'}{'text'}{'table'}{'side'} = '#000000';
$config->{'color'}{'background'}{'table'}{'normal'} = '#333333';
$config->{'color'}{'text'}{'table'}{'normal'} = '#cccccc';
$config->{'color'}{'text'}{'table'}{'percent'} = '#bbbbbb';
$config->{'color'}{'background'}{'table'}{'footer'} = '#aaaaaa';
$config->{'color'}{'text'}{'header'} = '#dddddd';
$config->{'trace'} = 1;
$config->{'html_header'} = 1;
$config->{'copyleft'} = 1;
$config->{'unsharp'} = 1;
$config->{'quote'}{'max'} = 80;
$config->{'quote'}{'min'} = 40;
$config->{'bar'}{'horizontal'}[0] = 'images/hor0n.png';
$config->{'bar'}{'horizontal'}[1] = 'images/hor1n.png';
$config->{'bar'}{'horizontal'}[2] = 'images/hor2n.png';
$config->{'bar'}{'horizontal'}[3] = 'images/hor3n.png';
$config->{'bar'}{'vertical'}[0] = 'images/ver0n.png';
$config->{'bar'}{'vertical'}[1] = 'images/ver1n.png';
$config->{'bar'}{'vertical'}[2] = 'images/ver2n.png';
$config->{'bar'}{'vertical'}[3] = 'images/ver3n.png';
$config->{'cgi'} = 0;
$config->{'type'} = 'perlbot';
$config->{'dancernick'} = '';
$config->{'dancermask'} = '';
$config->{'longlines'} = 50;
$config->{'shortlines'} = 10;
$config->{'overwrite'} = 0;
$config->{'plugin'} = ['core'];

$config->{'plugins'}{'minlines'} = 100;
$config->{'plugins'}{'nicks'}{'amount'} = 10;
$config->{'plugins'}{'soliloquies'}{'lines'} = 5;
$config->{'plugins'}{'topics'}{'amount'} = 5;
$config->{'plugins'}{'urls'}{'amount'} = 5;
$config->{'plugins'}{'urls'}{'ignore_quits'} = 1;
$config->{'plugins'}{'words'}{'amount'} = 10;
$config->{'plugins'}{'words'}{'minlength'} = 5;

# define the variables in that the values should be saved
my %file2intern = (	'generator'		=>	\$::user,
			'color_alink'		=>	\$config->{'color'}{'text'}{'alink'},
			'color_backgr_footer'	=>	\$config->{'color'}{'background'}{'table'}{'footer'},
			'color_backgr_header'	=>	\$config->{'color'}{'background'}{'table'}{'header'},
			'color_backgr_side'	=>	\$config->{'color'}{'background'}{'table'}{'side'},
			'color_backgr_table'	=>	\$config->{'color'}{'background'}{'table'}{'normal'},
			'color_background'	=>	\$config->{'color'}{'background'}{'normal'},
			'color_header'		=>	\$config->{'color'}{'text'}{'header'},
			'color_link'		=>	\$config->{'color'}{'text'}{'link'},
			'color_table'		=>	\$config->{'color'}{'text'}{'table'}{'normal'},
			'color_table_header'	=>	\$config->{'color'}{'text'}{'table'}{'header'},
			'color_table_percent'	=>	\$config->{'color'}{'text'}{'table'}{'percent'},
			'color_table_side'	=>	\$config->{'color'}{'text'}{'table'}{'side'},
			'color_text'		=>	\$config->{'color'}{'text'}{'normal'},
			'color_vlink'		=>	\$config->{'color'}{'text'}{'vlink'},
			'trace'			=>	\$config->{'trace'},
			'html_header'		=>	\$config->{'html_header'},
			'copyleft'		=>	\$config->{'copyleft'},
			'unsharp'		=>	\$config->{'unsharp'},
			'max_quote'		=>	\$config->{'quote'}{'max'},
			'min_quote'		=>	\$config->{'quote'}{'min'},
			'bar0h'			=>	\$config->{'bar'}{'horizontal'}[0],
			'bar1h'			=>	\$config->{'bar'}{'horizontal'}[1],
			'bar2h'			=>	\$config->{'bar'}{'horizontal'}[2],
			'bar3h'			=>	\$config->{'bar'}{'horizontal'}[3],
			'bar0v'			=>	\$config->{'bar'}{'vertical'}[0],
			'bar1v'			=>	\$config->{'bar'}{'vertical'}[1],
			'bar2v'			=>	\$config->{'bar'}{'vertical'}[2],
			'bar3v'			=>	\$config->{'bar'}{'vertical'}[3],
			'cgi'			=>	\$config->{'cgi'},
			'logtype'		=>	\$config->{'type'},
			'dancer_nick'		=>	\$config->{'dancernick'},
			'dancer_mask'		=>	\$config->{'dancermask'},
			'output'		=>	\$::output,
			'channel'		=>	\$::channel,
			'longlines'		=>	\$config->{'longlines'},
			'shortlines'		=>	\$config->{'shortlines'},
			'overwrite'		=>	\$config->{'overwrite'},
			'plugin'		=>	$config->{'plugin'},
			
			'plugin_minlines'	=>	\$config->{'plugins'}{'minlines'},
			'plugin_nicks_amount'	=>	\$config->{'plugins'}{'nicks'}{'amount'},
			'plugin_soliloquies_lines'=>	\$config->{'plugins'}{'soliloquies'}{'lines'},
			'plugin_topics_amount'	=>	\$config->{'plugins'}{'topics'}{'amount'},
			'plugin_urls_amount'	=>	\$config->{'plugins'}{'urls'}{'amount'},
			'plugin_urls_ignore_quits' =>	\$config->{'plugins'}{'urls'}{'ignore_quits'},
			'plugin_words_amount'	=>	\$config->{'plugins'}{'words'}{'amount'},
			'plugin_words_minlength'=>	\$config->{'plugins'}{'words'}{'minlength'}

			
		);
		
my %isarray = (plugin => 1);

# now we get the user's settings. I'll write an option to specify the
# CONFIGFILE by commandline the next days..
print "Reading config..\n" if $::debug;

open (CONFIGFILE, '< config') or die "Unable to open config file: $!\n";
foreach (<CONFIGFILE>)
{
	chomp ($_); # remove linebreak...
	s/;.*$//; # ignore (remove) comments
	s/[\s\t]//g; # remove spaces and tabs
	s/^(.+?:)/lc ($1)/e; # make keys lowercase

	next unless m/.:/;
	
	if ($_)
	{
		my ($key, $value) = split (/:/, $_, 2);

		next unless defined $file2intern{$key};

		if (defined $isarray{$key})
		{
			push (@{$file2intern{$key}}, $value);
		}
		elsif (defined $file2intern{$key})
		{
			${$file2intern{$key}} = $value;
		}
	}
}

close CONFIGFILE;

return 1;

sub plugins
{
	return @{$config->{'plugin'}};
}

sub get
{
	my ($caller) = caller ();

	if (defined $config->{'plugins'}{$caller})
	{
		return (%{$config->{'plugins'}{$caller}}, minlines => $config->{'plugins'}{'minlines'});
	}
	else
	{
		return (minlines => $config->{'plugins'}{'minlines'});
	}

	# you should never get here
	die;
}
