#=========================================================#
# onis 0.3.3                             2002-03-13 23:36 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# parser/dancer.pm                                        #
#=========================================================#


package parser;

use strict;
use vars qw( $data $myself );

require 'tools.pm';

*data = *::data;

my $trace = $main::data->{'config'}{'trace'};
$myself = $data->{'config'}{'dancernick'} or die "You have to set a nickname when using the dancer module!";

# here we add our own nick to the known hosts.
# We have to do this only once since it won't
# change (afaik..)
input::add_host ($data->{'config'}{'dancernick'} . '!' . $data->{'config'}{'dancermask'});

# perse it line by line..
sub parse
{
	my $line = shift or return undef;

# That's what the bouncer's owner wrote. We don't
# get his nick through the logfile so you have to
# tell us in the config file..
	if ($line =~ /^(\d\d).(\d\d).\d\d\s\>\>\>\s*\s\"say\s(.+)\"\s?/)
	{
		my ($hour, $minute, $text) = ($1, $2, $3);
		input::add_line ($myself, $text, $hour, $minute, 'text');
	}

# this looks like a normal line, so we add it to
# our hash (%$data) by using "input::add_line ();"
	if ($line =~ /^(\d\d).(\d\d).\d\d\s\#\s*\s\<([^>]+)\>\s(.+)/)
	{
		my ($hour, $minute, $nick, $text) = ($1, $2, $3, $4);
		input::add_line ($nick, $text, $hour, $minute, 'text');
	}

# somebody joined our channel.. It's time to
# register his host and name..
	if (($line =~ /^\[\d\d:\d\d\]\s([^<]\S+)\s\(([^\)]+)\) joined \#.+$/) and ($data->{'config'}{'trace'}))
	{
		input::add_host ($1 . '!' . $2);
	}

# Yeah, we can see soembody's host.. Let's
# remember it.. :)
	if (($line =~ /^\[\d\d:\d\d\]\s\#\S+\smode change.+by\s(\S+)$/) and ($data->{'config'}{'trace'}))
	{
		input::add_host ($1);
	}

# this gets called when somebody changes name:
# we just copy his data to a new nick..
	if (($line =~ /^\[\d\d:\d\d\]\sNick\schange:\s(\S+)\s->\s(\S+)$/) and ($data->{'config'}{'trace'}))
	{
		$data->{'nick2host'}{$2} = $data->{'nick2host'}{$1}
	}
}

1;
