#=========================================================#
# onis 0.3.3                             2002-03-29 21:41 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# parser/dircproxy.pm                                     #
#=========================================================#

package parser;

use strict;
use vars qw( $data );

require 'tools.pm';

*data = *::data;

my $trace = $data->{'config'}{'trace'};

sub parse
{
	my $line = shift;

# this looks like a normal line, so we add it to
# our hash (%$data) by using "input::add_line ();"
	if ($line =~ /^<([^!]+)!([^>]+)>\s\[(\d\d):(\d\d)\]\s(.+)$/)
	{
		my ($nick, $host, $hour, $minute, $text) = ($1, $2, $3, $4, $5);
		input::add_host ($nick . '!' . $host);
		input::add_line ($nick, $text, $hour, $minute, 'text');
	}

# somebody is doing an action
	elsif ($line =~ /^\[([^!]+)!([^>]+)\]\s\[(\d\d):(\d\d)\]\sACTION\s(.+)$/)
	{
		my ($nick, $host, $hour, $minute, $text) = ($1, $2, $3, $4, $5);
		input::add_host ($nick . '!' . $host);
		input::add_line ($nick, $text, $hour, $minute, 'action');
	}
	
# join
	elsif ($line =~ /^-\S+-\s\[(\d\d):(\d\d)\]\s(\S+)\s\(([^\)]+)\)\s/)
	{
		my ($hour, $minute, $nick, $user_and_host) = ($1, $2, (lc $3), (lc $4));
		input::add_host ($nick . '!' . $user_and_host);
	}

# kick
	elsif ($line =~ /^-\S+-\s\[(\d\d):(\d\d)\]\s(\S+)\skicked\soff\sby\s(\S+)\s\(([^\)]+)\):\s(.+)$/)
	{
		my ($hour, $minute, $nick_received, $nick_given, $user_host_given, $reason) = ($1, $2, $3, $4, $5, $6);
		input::add_host ($nick_given . '!' . $user_host_given);
		input::add_line ($nick_received, $reason, $hour, $minute, 'kick_received');
		input::add_line ($nick_given,    $reason, $hour, $minute, 'kick_given'   );
	}

	elsif ($main::debug)
	{
		print "Not parsed: $line\n";
	}
}

1;
