#=========================================================#
# onis 0.3.3                             2002-03-29 17:43 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/actions.pm                                      #
#=========================================================#

package actions;

use strict;
use Config;

use vars qw(
		$data $_data %config
		$first $quote $total
	);

*data = *::data;
$_data = {};
%config = Config->get or return undef;

push (@{$::plugins{'action'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

return 1;

sub add
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "actions::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;
	
	push (@{$_data->{$nick}}, $line);
}

sub calculate
{
	$first = '';
	$quote = '';
	$total = 0;
	
	foreach my $final_nick (@::nicklist)
	{
		my @actions = ();
		
		next unless ($data->{'finalhash'}{$final_nick}{'general'} > $config{'minlines'});
		
		foreach my $used_nick (@{$::allnicks{$final_nick}})
		{
			next unless defined $_data->{$used_nick};

			push (@actions, @{$_data->{$used_nick}});
		}

		my $total_actions = scalar @actions;

		if ($total_actions > $total)
		{
			$total = $total_actions;
			$first = $final_nick;
			$quote = html::escape ($actions[(int (rand ($total)))]);
		}
	}
}

sub output
{
	return undef unless $total;

	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr><td><em>$first</em> had the most action going on.. Whole $total times. Here's an example:<br>
\&quot;$quote\&quot;</td></tr>
</table>
</div>

EOF
}
