#=========================================================#
# onis 0.3.3                             2002-03-29 20:23 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/kicks.pm                                        #
#=========================================================#

package kicks;

use strict;

use vars qw(
		$data $_data %config
		$count_given $count_received
		$nick_given $nick_received
		$reason
	);

*data = *::data;
$_data = {};
%config = Config->get () or return undef;

push (@{$::plugins{'kick_received'}}, \&add);
push (@{$::plugins{'kick_given'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

return 1;

sub add
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "kicks::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;
	
	if ($type eq 'kick_received')
	{
		push (@{$_data->{'received'}{$nick}}, $line);
	}
	else
	{
		++$_data->{'given'}{$nick};
	}
}

sub calculate
{
	$count_given = 0;
	$count_received = 0;
	$nick_given = '';
	$nick_received = '';
	$reason = '';
	
	foreach my $final_nick (@::nicklist)
	{
		next unless ($data->{'finalhash'}{$final_nick}{'general'} > $config{'minlines'});

		my @received = ();
		my $given = 0;
		
		foreach my $used_nick (@{$::allnicks{$final_nick}})
		{
			if (defined $_data->{'received'}{$used_nick})
			{
				push (@received, @{$_data->{'received'}{$used_nick}});
			}

			if (defined $_data->{'given'}{$used_nick})
			{
				$given += $_data->{'given'}{$used_nick};
			}
		}

		my $received = scalar @received;
		if ($received > $count_received)
		{
			$count_received = $received;
			$nick_received = $final_nick;
			$reason = $received[int (rand ($received))];
		}

		if ($given > $count_given)
		{
			$count_given = $given;
			$nick_given = $final_nick;
		}
	}		
}

sub output
{
	return undef unless ($count_received or $count_given);
	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr><td>
EOF
	if ($count_received)
	{
		print html::OUT "<em>$nick_received</em> seems to be a little annoying. He got kicked $count_received times. A reason was \&quot;$reason\&quot;";
	}
	if ($count_received and $count_given) { print html::OUT "<br />\n"; }
	if ($count_given)
	{
		print html::OUT "The person easiest to anger is $nick_given: He kicked $count_given times.";
	}
	
	print html::OUT <<EOF;
</td></tr>
</table>
</div>

EOF
}
