#=========================================================#
# onis 0.3.3                             2002-03-29 20:24 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/longlines.pm                                    #
#=========================================================#

package longlines;

use strict;

use vars qw(
		$data $_data %config
		$first $last $average_first $average_last
		$channel_lines $channel_chars $channel_average
	);

*data = *::data;
$_data = {};
%config = Config->get or return undef;

push (@{$::plugins{'text'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

$channel_lines = 0;
$channel_chars = 0;
$channel_average = 0;

return 1;

sub add
# averange line length
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "longlines::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;
	
	++$channel_lines;
	$channel_chars += length ($line);
	$_data->{$nick} += length ($line);
}

sub calculate
{
	$first = '';
	$last = '';
	$average_first = 0;
	$average_last = 1000000;
	
# Iterates through every nick and calculates
# average = int(total characters / total lines)
	foreach my $final_nick (@::nicklist)
	{
		my $total_length = 0;
		my $total_lines  = $data->{'finalhash'}{$final_nick}{'general'};
		
		next unless ($total_lines > $config{'minlines'});

		foreach my $used_nick (@{$::allnicks{$final_nick}})
		{
			next unless defined $_data->{$used_nick};
			$total_length += $_data->{$used_nick};
		}

# Calculates the average of this person's lines
		my $average = (int ((10 * $total_length) / $total_lines) / 10);

		if ($average > $average_first)
		{
			$average_first = $average;
			$first = $final_nick;
		}
		elsif ($average < $average_last)
		{
			$average_last = $average;
			$last = $final_nick;
		}
	}

# Calculates the overall channel average the same way
	if ($channel_lines)
	{
		$channel_average = (int ((10 * $channel_chars) / $channel_lines) / 10);
	}
}

sub output
{
	return undef unless ($average_first or ($average_last != 1000000) or $channel_average); #all of them should always be present..
	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr><td>
EOF
	my @out = ();
	push (@out, "Channel average: $channel_average..") if $channel_average;
	push (@out, "Longest lines by <em>$first</em> (average: $average_first)") if $average_first;
	push (@out, "Shortest lines by <em>$last</em> (average: $average_last)") if ($average_last != 1000000);
	print html::OUT join ("<br />\n", @out);
	
	print html::OUT <<EOF;
</td></tr>
</table>
</div>

EOF
}
