#=========================================================#
# onis 0.3.3                             2002-03-29 20:24 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/nicks.pm                                        #
#=========================================================#

package nicks;

use strict;

use vars qw(
		$data $_data %config
		@nicks @counts
		@usedby
	);

*data = *::data;
$_data = {};
%config = Config->get or return undef;

push (@{$::plugins{'text'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

return 1;

sub add
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "nicks::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;
	
	my @potential_nicks = split (/\s+/, $line);

	foreach my $pot_nick (@potential_nicks)
	{
		$pot_nick =~ s/[!\?\.]+$//g;
		if (defined $data->{'nick2host'}{$pot_nick})
		{
			++$_data->{$pot_nick}{'count'};
			$_data->{$pot_nick}{'last_used_by'} = $nick;
		}
	}

	return 1;
}

sub calculate
{
	@nicks = (sort { $_data->{$b}{'count'} <=> $_data->{$a}{'count'} } (keys %$_data));
	if (scalar @nicks > $config{'amount'}) { splice (@nicks, $config{'amount'}); }
	
	@counts = ();
	@usedby = ();

	foreach (@nicks)
	{
		push (@counts, $_data->{$_}{'count'});
		push (@usedby, $_data->{$_}{'last_used_by'});
	}
}

sub output
{
	return undef unless scalar @counts;
	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr>
<td class="invis">&nbsp;</td>
<td class="header">Nick</td>
<td class="header">Times used</td>
<td class="header">Last used by</td>
</tr>
EOF
	my $i = 0;
	foreach my $n (@nicks)
	{
		++$i;
		my $count = shift (@counts);
		my $by = shift (@usedby);
		
		print html::OUT "<tr>\n";
		print html::OUT "  <td class=\"numeration\">$i</td>\n";
		print html::OUT "  <td>$n</td>\n";
		print html::OUT "  <td>$count</td>\n";
		print html::OUT "  <td>$by</td>\n";
		print html::OUT "</tr>\n";
	}
	print html::OUT <<EOF;

</table>
</div>
<br>

EOF
}
