#=========================================================#
# onis 0.3.3                             2002-03-29 18:26 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/questions.pm                                    #
#=========================================================#

package questions;
# Look for a line with a question mark following at least one character but
# after all the word characters.
# (Allows "What?" "What?!?!" and "What? " But not "What? *wonder*" etc.)

use strict;

use vars qw(
		$data $_data %config
		$first $percent_first
	);

*data = *::data;
$_data = {};
%config = Config->get or return undef;

push (@{$::plugins{'text'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

sub add
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "questions::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;

	if ($line =~ /\w[^\?]*\?\W*$/)
	{
		++$_data->{$nick};
	}
}

sub calculate
{
	$first = '';
	$percent_first = 0;

	foreach my $final_nick (@::nicklist)
	{
		my $nick_total = 0;
		my $total_lines  = $data->{'finalhash'}{$final_nick}{'general'};
		my $main_host;

		next unless ($total_lines > $config{'minlines'});

		foreach my $used_nick (@{$::allnicks{$final_nick}})
		{
			next unless defined $_data->{$used_nick};

			$nick_total += $_data->{$used_nick};
		}
		
		my $percent = int ((100 * $nick_total) / $total_lines);
		
		if ($percent > $percent_first)
		{
			$percent_first = $percent;
			$first = $final_nick;
		}
	}
}

sub output
{
	return undef unless $percent_first;
	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr><td><em>$first</em> was very interested. $percent_first\% of the lines were questions..</td></tr>
</table>
</div>

EOF
}

1;
