#=========================================================#
# onis 0.3.3                             2002-03-29 20:55 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/quits.pm                                        #
#=========================================================#

package quits;

use strict;

use vars qw(
		$data $_data %config
		$first $quote $total
	);

*data = *::data;
$_data = {};
%config = Config->get or return undef;

push (@{$::plugins{'quit'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

sub add
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "quits::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;

	if ($line =~ m/ping\stimeout|connection\sreset|leaving|eof\sfrom\sclient/i)
	{
		return 0;
	}
	
	$_data->{$nick}{$line} = 1;
}

sub calculate
{
	$first = '';
	$quote = '';
	$total = 0;
	
	foreach my $final_nick (@::nicklist)
	{
		my %quits = ();
		
		next unless ($data->{'finalhash'}{$final_nick}{'general'} > $config{'minlines'});
		
		foreach my $used_nick (@{$::allnicks{$final_nick}})
		{
			next unless defined $_data->{$used_nick};

			foreach (keys %{$_data->{$used_nick}}) { $quits{$_} = 1; }
		}

		my @quits = keys %quits;
		
		my $total_quits = scalar @quits;

		if ($total_quits > $total)
		{
			$total = $total_quits;
			$first = $final_nick;
			$quote = html::escape ($quits[(int (rand ($total)))]);
		}
	}
}

sub output
{
	return undef unless $total;

	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr><td><em>$first</em> was very creative! He had $total different quit messages. Here's an example:<br>
\&quot;$quote\&quot;</td></tr>
</table>
</div>

EOF
}

1;
