#=========================================================#
# onis 0.3.3                             2002-03-29 18:28 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/soliloquies.pm                                  #
#=========================================================#

package soliloquies;

use strict;

use vars qw(
		$data $_data %config
		$lastnick $lines
		$first $total
	);

*data = *::data;
$_data = {};
%config = Config->get or return undef;

push (@{$::plugins{'text'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

$lastnick = '';
$lines = 0;

sub add
# soliloquies
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "soliloquies::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;
	
	if ($nick eq $lastnick)
	{
		++$lines;

		if ($lines == $config{'lines'})
		{
			++$_data->{$nick};
			$lines = 0;
		}
	}
	else
	{
		$lastnick = $nick;
		$lines = 1;
	}
}

sub calculate
{
	$first = '';
	$total = 0;

	foreach my $final_nick (@::nicklist)
	{
		next unless ($data->{'finalhash'}{$final_nick}{'general'} > $config{'minlines'});

		my $nick_total = 0;

		foreach my $used_nick (@{$::allnicks{$final_nick}})
		{
			next unless defined $_data->{$used_nick};

			$nick_total += $_data->{$used_nick};
		}

		if ($nick_total > $total)
		{
			$total = $nick_total;
			$first = $final_nick;
		}
	}
}

sub output
{
	return undef unless $total;
	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr><td><em>$first</em> used the most soliloquies: $total times!</td></tr>
</table>
</div>

EOF
}

1;
