#=========================================================#
# onis 0.3.3                             2002-03-29 18:30 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/topics.pm                                       #
#=========================================================#

package topics;

use strict;

use vars qw(
		$data $_data %config
		@topics @setby
	);

*data = *::data;
$_data = {};
@topics = ();
@setby = ();
%config = Config->get or return undef;

push (@{$::plugins{'topic'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

sub add
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "topicss::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;
	
	push (@topics, $line);
	push (@setby, $nick);
}

sub calculate
{
	my $c = {};
	my $count = 0;

	foreach my $topic (reverse @topics)
	{
		my $by = pop (@setby);
		if (!exists $c->{$topic})
		{
			$c->{$topic}{'count'} = ++$count;
			$c->{$topic}{'setby'} = $by;
		}

		last if $count == $config{'amount'};
	}
	@topics = ();
	@setby = ();

	@topics = (sort { $c->{$a}{'count'} <=> $c->{$b}{'count'} } (keys %$c));
	foreach (@topics) { push (@setby, $c->{$_}{'setby'}); }
}

sub output
{
	return undef unless scalar @topics;

	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr>
<td class="invis">&nbsp;</td>
<td class="header">Topic</td>
<td class="header">Set by</td>
</tr>
EOF

	my $i = 0;
	foreach my $t (@topics)
	{
		++$i;
		my $by = shift (@setby);

		$t = html::escape ($t);
		
		html::output (	"<tr>\n",
				"  <td class=\"numeration\">$i</td>\n",
				"  <td>$t</td>\n",
				"  <td>$by</td>\n",
				"</tr>\n");
	}

	print html::OUT <<EOF;
</table>
</div>
<br>

EOF
	
}

1;
