#=========================================================#
# onis 0.3.3                             2002-03-29 18:55 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/urls.pm                                         #
#=========================================================#

package urls;

use strict;
use Config;

use vars qw(
		$data $_data %config
		@urls @counts
	);

*data = *::data;
$_data = {};
%config = Config->get () or return undef;

push (@{$::plugins{'text'}}, \&add);
push (@{$::plugins{'action'}}, \&add);
push (@{$::plugins{'topic'}}, \&add);

if (!$config{'ignore_quits'})
{
	push (@{$::plugins{'quit'}}, \&add);
}

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

sub add
# averange line length
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "urls::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;
	
#	if ($line =~ /(?:(?:ftp|https?):\/\/|www\.)[\w@\.:]*[a-z0-9]+\.[a-z]{2,4}(?:\/[^\][{}\s\n\r\"<>\(\)]*[^\][{}\s\n\r\"<>\(\)\.,:])?\/?(?=\W|$)/)
	if ($line =~ m#(?:(?:ftp|https?)://|www\.)[a-z0-9_\.-]+\.[a-z]{2,4}(?:\d+)?(?:/[\w\d\.\%/-]+)?(?=\W|$)#)
	{
		my $match = $&;

		if ($match =~ /^www/) { $match = 'http://' . $match; }
		if ($match !~ /:\/\/.+\//) { $match .= '/'; }
		
		if (defined $_data->{$match})
		{
			++$_data->{$match};
		}
		else
		{
			$_data->{$match} = 1;
		}
	}
}

sub calculate
{
	@urls = (sort { $_data->{$b} <=> $_data->{$a} } (keys %$_data));
	if (scalar @urls > $config{'amount'}) { splice (@urls, $config{'amount'}); }

	@counts = ();
	
	foreach (@urls)
	{
		push (@counts, $_data->{$_});
	}
}

sub output
{
	return undef unless scalar @counts;

	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr>
  <td class="invis">&nbsp;</td>
  <td class="header">URL</td>
  <td class="header">Times used</td>
</tr>
EOF
	my $i = 0;
	foreach my $u (@urls)
	{
		++$i;
		my $count = shift (@counts);

		print html::OUT "<tr>\n";
		print html::OUT "  <td class=\"numeration\">$i</td>\n";
		print html::OUT "  <td><a href=\"$u\" target=\"_blank\">$u</a></td>\n";
		print html::OUT "  <td>$count</td>\n";
		print html::OUT "</tr>\n";
	}

	print html::OUT <<EOF;
</table>
</div>
<br>

EOF
}

1;
