#=========================================================#
# onis 0.3.3                             2002-03-29 18:32 #
# http://verplant.org/onis/                               #
# Florian Forster <flo@verplant.org>                      #
#                                                         #
# plugins/yells.pm                                        #
#=========================================================#

package yells;

use strict;

use vars qw(
		$data $_data %config
		$first $second
		$percent_first $percent_second
	);

*data = *::data;
$_data = {};
%config = Config->get or return undef;

push (@{$::plugins{'text'}}, \&add);

push (@{$::plugins{'calculate'}}, \&calculate);
push (@{$::plugins{'output'}}, \&output);

sub add
# averange line length
{
	my ($nick, $line, $hour, $minute, $type, $host) = @_;

	print "yells::add ($nick, $line, $hour, $minute, $type, $host);\n" if $::debug > 1;

	if ($line eq (uc $line) and $line =~ /\w{3}/)
	{
		++$_data->{$nick};
	}
}

sub calculate
{
	$first = '';
	$second= '';
	$percent_first = 0;
	$percent_second= 0;

	foreach my $final_nick (@::nicklist)
	{
		my $total_yells = 0;
		my $total_lines  = $data->{'finalhash'}{$final_nick}{'general'};

		next unless ($total_lines > $config{'minlines'});

		foreach my $used_nick (@{$::allnicks{$final_nick}})
		{
			next unless defined $_data->{$used_nick};

			$total_yells += $_data->{$used_nick};
		}

		my $percent = int ((100 * $total_yells) / $total_lines);

		if ($percent > $percent_first)
		{
			$second = $first;
			$percent_second = $percent_first;

			$first = $final_nick;
			$percent_first = $percent;
		}
		elsif ($percent > $percent_second)
		{
			$second = $final_nick;
			$percent_second = $percent;
		}
	}
}

sub output
{
	return undef unless $percent_first;

	print html::OUT <<EOF;
<div>
<table border="0" cellspacing="1" width="400">
<tr><td><em>$first</em> yelled the most ($percent_first\% of all his lines..)
EOF
	print html::OUT "<br>\nthe next is <em>$second</em> with $percent_second percent of all his lines yelled.." if $percent_second;
	print html::OUT <<EOF;
</td></tr>
</table>
</div>

EOF
}

1;
